#include "lib.h"
#include "player.h"
#include "ghost.h"
#include "laby_data.h"
#include <stdio.h>
#include <stdlib.h>
#include <string.h>


#define IMG_BLANK 0


#define screen(x,y) ((unsigned char*)precalc_vram[y]+(x>>1))

extern const unsigned char pacman_sprites[];
extern const unsigned char blank_sprites[];
extern const unsigned char ghost_sprites[];
extern const unsigned char tiles[];
extern unsigned char laby[];

extern unsigned int precalc_vram[200];

extern s_player player;
extern s_ghost ghost[4];

unsigned char *spr_img[25];
unsigned char *tiles_img[26];


const unsigned char game_palette[]=
{
		0,25,7,8,11,16,22,26,0,0,0,0,0,0,0,0
};

void render_background(unsigned char x,unsigned char y)
{
		unsigned int xtile,ytile;
		unsigned int ntile;
		unsigned int xpix,ypix;
		
		// Récupération du code tile en x,y
		xtile = (unsigned int)x>>2;
		ytile = (unsigned int)y>>3;
		ntile = (unsigned int)(ytile*40)+xtile;
		
		xpix = (xtile<<2);
		ypix = (ytile<<3);
		
		put_frame(screen(xpix,ypix),2,8,tiles_img[laby[ntile]]);
		put_frame(screen((xpix+4),ypix),2,8,tiles_img[laby[ntile+1]]);

		put_frame(screen(xpix,(ypix+8)),2,8,tiles_img[laby[ntile+40]]);
		put_frame(screen((xpix+4),(ypix+8)),2,8,tiles_img[laby[ntile+41]]);
	
}

void waito(void)
{
		
}

void main(void)
{
	char i;
	unsigned int cpt,x,y;
	
	
	// Image vide
	spr_img[IMG_BLANK] = (unsigned char *)blank_sprites;
	// Pacman rond
	spr_img[1] = (unsigned char *)pacman_sprites;
	// Pacman Anim gauche
	spr_img[2] = (unsigned char *)pacman_sprites;
	spr_img[3] = (unsigned char *)pacman_sprites + (PLAYER_SPRITE_HAUTEUR*PLAYER_SPRITE_LARGEUR_O);
	spr_img[4] = (unsigned char *)pacman_sprites + ((PLAYER_SPRITE_HAUTEUR*PLAYER_SPRITE_LARGEUR_O)*2);
	// Pacman Anim Droite
	spr_img[5] = (unsigned char *)pacman_sprites;
	spr_img[6] = (unsigned char *)pacman_sprites + ((PLAYER_SPRITE_HAUTEUR*PLAYER_SPRITE_LARGEUR_O)*3);
	spr_img[7] = (unsigned char *)pacman_sprites + ((PLAYER_SPRITE_HAUTEUR*PLAYER_SPRITE_LARGEUR_O)*4);
	// Pacman Anim haut
	spr_img[8] = (unsigned char *)pacman_sprites;
	spr_img[9] = (unsigned char *)pacman_sprites + ((PLAYER_SPRITE_HAUTEUR*PLAYER_SPRITE_LARGEUR_O)*5);
	spr_img[10] = (unsigned char *)pacman_sprites + ((PLAYER_SPRITE_HAUTEUR*PLAYER_SPRITE_LARGEUR_O)*6);
	// Pacman Anim Bas
	spr_img[11] = (unsigned char *)pacman_sprites;
	spr_img[12] = (unsigned char *)pacman_sprites + ((PLAYER_SPRITE_HAUTEUR*PLAYER_SPRITE_LARGEUR_O)*7);
	spr_img[13] = (unsigned char *)pacman_sprites + ((PLAYER_SPRITE_HAUTEUR*PLAYER_SPRITE_LARGEUR_O)*8);
	// Fantome 1
	spr_img[14] = (unsigned char *)ghost_sprites;
	spr_img[15] = (unsigned char *)ghost_sprites + (GHOST_SPRITE_HAUTEUR*GHOST_SPRITE_LARGEUR_O);
	// Fantome 2
	spr_img[16] = (unsigned char *)ghost_sprites + ((GHOST_SPRITE_HAUTEUR*GHOST_SPRITE_LARGEUR_O)*2);
	spr_img[17] = (unsigned char *)ghost_sprites + ((GHOST_SPRITE_HAUTEUR*GHOST_SPRITE_LARGEUR_O)*3);
	// Fantome 3
	spr_img[18] = (unsigned char *)ghost_sprites + ((GHOST_SPRITE_HAUTEUR*GHOST_SPRITE_LARGEUR_O)*4);
	spr_img[19] = (unsigned char *)ghost_sprites + ((GHOST_SPRITE_HAUTEUR*GHOST_SPRITE_LARGEUR_O)*5);
	// Fantome 4
	spr_img[20] = (unsigned char *)ghost_sprites + ((GHOST_SPRITE_HAUTEUR*GHOST_SPRITE_LARGEUR_O)*6);
	spr_img[21] = (unsigned char *)ghost_sprites + ((GHOST_SPRITE_HAUTEUR*GHOST_SPRITE_LARGEUR_O)*7);	
	// Fantome Appeuré
	spr_img[22] = (unsigned char *)ghost_sprites + ((GHOST_SPRITE_HAUTEUR*GHOST_SPRITE_LARGEUR_O)*8);
	spr_img[23] = (unsigned char *)ghost_sprites + ((GHOST_SPRITE_HAUTEUR*GHOST_SPRITE_LARGEUR_O)*9);
	
	// Les tiles démarrent à 1, la tile 0 est une tile transparente dans
	// Tiled. Non utilisé ici.
	for (i=0;i<26;i++)
		tiles_img[i+1]= (unsigned char *)tiles + ((2*8)*i);
	
	screen_mode0();
	set_palette(game_palette);
	vsync();
	
	cpt=0;
	
	laby_init();
	
	for (y=0;y<25;y++)
	{
		for (x=0;x<40;x++)
		{
			// x et y doivent être des UNSIGNED INT PASSE A CETTE FONCTION
			// Sinon glitch, certainement du à une conversion de type foireuse qqpart ...
			// cpt --> Unsigned int car peut aller jusqu'à 25*40
			put_frame(screen((x*4),(y*8)),2,8,tiles_img[laby[cpt]]);
			cpt++;
			
		}
	}
	
	player_init();
	ghost_init();
	
	while(1)
	{
		check_controller();
		player_control();
		ghost_ia();

		
		/* Rendu graphique */		
		vsync();		
		render_background(player.oldx,player.oldy);
		put_frame(screen(player.x,player.y), PLAYER_SPRITE_LARGEUR_O, PLAYER_SPRITE_HAUTEUR, spr_img[player.dc+player.anim]);		
	
		/*
		for (i=0;i<4;i++)
		{	
			render_background(ghost[i].oldx,ghost[i].oldy);
			put_frame(screen(ghost[i].x,ghost[i].y), GHOST_SPRITE_LARGEUR_O, GHOST_SPRITE_HAUTEUR, spr_img[14+(i<<1)+ghost[i].anim]);				
		}
		*/

	}
}